;=================================================================
ScriptName aaajcsRedditMascot Extends ReferenceAlias
;=================================================================
Actor Property PlayerRef Auto
Message Property aaajcsRedditMascotDownvotedMESG Auto
Message Property aaajcsRedditMascotUpvotedMESG Auto
Message Property aaajcsRedditMascotUserProfileMESG Auto
SoundCategory Property AudioCategoryVOC Auto
SoundCategory Property AudioCategoryVOCGeneral Auto
Spell Property aaajcsRedditRuleBreakerSPEL Auto
;=================================================================
Actor Mascot
Bool Upvoted
;=================================================================
State Subbed
	 ;=======================
	 Event OnActivate(ObjectReference akActionRef)
		 If akActionRef == PlayerRef
			 GetKarma()
		 EndIf
	 EndEvent
	 ;=======================
	 Event OnBeginState()
		 Utility.Wait(0.5)
		 If Mascot.IsInCombat()
			 Mascot.StopCombat()
		 EndIf
		 If !Mascot.IsPlayerTeammate()
			 Mascot.SetPlayerTeammate(abCanDoFavor = False)
			 Mascot.EvaluatePackage()
		 EndIf
	 EndEvent
	 ;=======================
	 Event OnEndState()
		 If Upvoted
			 Upvoted = False
			 AudioCategoryVOC.SetFrequency(1.0)
			 AudioCategoryVOCGeneral.SetFrequency(1.0)
		 EndIf
	 EndEvent
	 ;=======================
	 Event OnCombatStateChanged(Actor akTarget,int aeCombatState)
		 Utility.Wait(1.0)
		 If Mascot.IsInCombat() || PlayerRef.IsInCombat()
			 GoToState("TrollDetected")
		 EndIf
	 EndEvent
	 ;=======================
	 Event OnCellDetach()
		 GoToState("ShadowBanned")
	 EndEvent
	 ;=======================
EndState
;=================================================================
State ShadowBanned
	 Event OnBeginState()
		 Utility.Wait(5.0)
		 If Mascot.GetDistance(PlayerRef) > 2000.0
			 Utility.Wait(5.0)
			 If Mascot.GetDistance(PlayerRef) > 2000.0
				 Float PZ = PlayerRef.GetAngleZ()
				 Mascot.Disable()
				 Mascot.MoveTo(PlayerRef,-100.0 * Math.Sin(PZ),-100.0 * Math.Cos(PZ),0.0)
				 Utility.Wait(1.0)
				 Mascot.Enable()
			 EndIf
		 EndIf
		 GoToState("Subbed")
	 EndEvent
EndState
;=================================================================
State Unsubbed
	 ;=======================
	 Event OnBeginState()
		 ;=======================
		 Mascot.PlaceAtMe(Game.GetFormFromFile(0x7CD55,"Skyrim.esm"))
		 Utility.Wait(1.0)
		 Mascot.RemoveFromFaction(Game.GetFormFromFile(0x1900,"RedditMascot.esp") as Faction)
		 Mascot.SetPlayerTeammate(False)
		 Mascot.MoveTo(Game.GetFormFromFile(0x1DC0A,"Skyrim.esm") as ObjectReference,0.0,0.0,0.0)
		 Utility.Wait(0.1)
		 Mascot.EvaluatePackage()
		 ;=======================
	 EndEvent
	 ;=======================
	 Event OnLoad()
		 Mascot.UnEquipAll()
		 Utility.Wait(0.1)
		 Mascot.EquipItem(Game.GetFormFromFile(0x809,"RedditMascot.esp") as Armor,True)
	 EndEvent
	 ;=======================
	 Event OnActivate(ObjectReference akActionRef)
		 If akActionRef == PlayerRef && (Game.GetFormFromFile(0x810,"RedditMascot.esp") as Message).Show() == 1
			 Mascot.AddToFaction(Game.GetFormFromFile(0x1900,"RedditMascot.esp") as Faction)
			 Debug.Notification("????? is now following you")
			 GoToState("Subbed")
		 EndIf
	 EndEvent
	 ;=======================
EndState
;=================================================================
State TrollDetected
	 Event OnBeginState()
		 Mascot.SetPlayerTeammate(False)
		 Mascot.StopCombatAlarm()
		 Mascot.EvaluatePackage()
		 Utility.Wait(1.0)
		 While PlayerRef.IsInCombat()
			 Utility.Wait(10.0)
		 EndWhile
		 If Mascot.IsInCombat()
			 Mascot.StopCombat()
		 EndIf
		 GoToState("ShadowBanned")
	 EndEvent
EndState
;=================================================================
Function GetKarma()
	 ;=======================
	 Int FrontPage
	 If Upvoted
		 FrontPage = aaajcsRedditMascotUpvotedMESG.Show()
	 ElseIf Utility.RandomInt(1,20) == 15
		 FrontPage = (Game.GetFormFromFile(0x18DE,"RedditMascot.esp") as Message).Show()
	 Else
		 FrontPage = aaajcsRedditMascotDownvotedMESG.Show()
	 EndIf
	 Utility.Wait(0.1)
	 ;=======================
	 If FrontPage == 1
		 FrontPage = aaajcsRedditMascotUserProfileMESG.Show()
		 If FrontPage == 1
			 (Game.GetFormFromFile(0x18CF,"RedditMascot.esp") as Message).Show()
		 ElseIf FrontPage == 2 && (Game.GetFormFromFile(0xD87,"RedditMascot.esp") as Message).Show() == 1
			 Debug.Notification("????? is no longer following you")
			 GoToState("Unsubbed")
		 EndIf
	 ;=======================
	 ElseIf FrontPage == 2
		 Spell HappyFreeze = Game.GetFormFromFile(0x18D3,"RedditMascot.esp") as Spell
		 If !PlayerRef.HasSpell(HappyFreeze)
			 PlayerRef.AddSpell(HappyFreeze,False)
			 PlayerRef.EquipSpell(HappyFreeze,0)
			 PlayerRef.EquipSpell(HappyFreeze,1)
			 Debug.Notification("Happy Freeze Spell Armed!")
		 Else
			 Spell Left = PlayerRef.GetEquippedSpell(0)
			 Spell Right = PlayerRef.GetEquippedSpell(1)
			 If Left && Left == HappyFreeze
				 PlayerRef.UnEquipSpell(Left,0)
			 EndIf
			 If Right && Right == HappyFreeze
				 PlayerRef.UnEquipSpell(Right,1)
			 EndIf
			 PlayerRef.RemoveSpell(HappyFreeze)
			 Debug.Notification("Happy Freeze Spell Removed")
		 EndIf
	 ;=======================
	 ElseIf FrontPage == 3
		 Int Downvotes = Utility.RandomInt(15,20)
		 Int VoteFuzzer
		 Mascot.TranslateTo(Mascot.x,Mascot.y,Mascot.GetPositionZ() + 500.0,Mascot.x,Mascot.y,Mascot.z,80.0)
		 (Game.GetFormFromFile(0x1B212,"Skyrim.esm") as EffectShader).Play(Mascot,5.0)
		 Utility.Wait(0.5)
		 While Downvotes > 0
			 Downvotes -= 1
			 Actor ToChange = Game.FindRandomActorFromRef(Mascot,1500.0)
			 If ToChange && ToChange != Mascot && ToChange != PlayerRef && !ToChange.IsDead()
				 aaajcsRedditRuleBreakerSPEL.Cast(Mascot,ToChange)
				 VoteFuzzer += 1
			 EndIf
			 Utility.Wait(0.1)
		 EndWhile
		 If Upvoted
			 Utility.Wait(0.1)
			 Upvoted = False
			 AudioCategoryVOC.SetFrequency(1.0)
			 AudioCategoryVOCGeneral.SetFrequency(1.0)
		 ElseIf VoteFuzzer > 0
			 Upvoted = True
			 If Utility.RandomInt(1,2) == 1
				 AudioCategoryVOC.SetFrequency(0.75)
				 AudioCategoryVOCGeneral.SetFrequency(0.75)
			 Else
				 AudioCategoryVOC.SetFrequency(1.25)
				 AudioCategoryVOCGeneral.SetFrequency(1.25)
			 EndIf
		 Else
			 Debug.Notification("No bystanders found to modify...")
		 EndIf
		 Mascot.StopTranslation()
		 Utility.Wait(0.1)
		 Debug.SendAnimationEvent(Mascot,"IdleForceDefaultState")
	 ;=======================
	 ElseIf FrontPage == 4
		 Float PZ = PlayerRef.GetAngleZ()
		 ObjectReference Blank = Mascot.PlaceAtMe(Game.GetFormFromFile(0xB79FF,"Skyrim.esm"))
		 Blank.MoveTo(PlayerRef,400.0 * Math.Sin(PZ),400.0 * Math.Cos(PZ),200.0)
		 Mascot.TranslateToRef(Blank,100.0)
		 ObjectReference RedditAnvil = (Game.GetFormFromFile(0x1879,"RedditMascot.esp") as ObjectReference).PlaceAtMe(Game.GetFormFromFile(0xD8F,"RedditMascot.esp") as MiscObject)
		 Utility.Wait(1.0)
		 RedditAnvil.SetScale(10.0)
		 RedditAnvil.MoveTo(PlayerRef,0.0,0.0,500.0)
		 Utility.Wait(0.8)
		 Mascot.PushActorAway(PlayerRef,0.0)
		 Mascot.TranslateToRef(PlayerRef,80.0)
		 Utility.Wait(3.0)
		 RedditAnvil.Disable(True)
		 Utility.Wait(0.1)
		 Mascot.StopTranslation()
		 Utility.Wait(0.1)
		 Debug.SendAnimationEvent(Mascot,"IdleForceDefaultState")
		 Utility.Wait(2.0)
		 RedditAnvil.Delete()
		 Blank.Delete()
	 EndIf
	 ;=======================
EndFunction
;=================================================================
;Event OnInit();		OnInstantInit
	 ;Utility.Wait(1.0)
	 ;Mascot = GetActorReference()
	 ;Mascot.AddToFaction(Game.GetFormFromFile(0x1900,"RedditMascot.esp") as Faction)
	 ;Mascot.EquipItem(Game.GetFormFromFile(0x809,"RedditMascot.esp") as Armor,True)
	 ;Mascot.MoveTo(PlayerRef,-300.0 * Math.Sin(PlayerRef.GetAngleZ()),-300.0 * Math.Cos(PlayerRef.GetAngleZ()),200.0)
	 ;GoToState("Subbed")
;EndEvent
;=================================================================
Event OnInit();		OnTraditionalInit
	 Utility.Wait(1.0)
	 Mascot = GetActorReference()
	 Mascot.EquipItem(Game.GetFormFromFile(0x809,"RedditMascot.esp") as Armor,True)
	 Mascot.MoveTo(Game.GetFormFromFile(0x1DC0A,"Skyrim.esm") as ObjectReference,0.0,0.0,0.0)
	 GoToState("Unsubbed")
EndEvent
;=================================================================
Event OnActivate(ObjectReference akActionRef)
EndEvent
;=================================================================